EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_FLIP_EVENT_ANIMATE_BEGIN =
   EFL_EVENT_DESCRIPTION("animate,begin");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_FLIP_EVENT_ANIMATE_DONE =
   EFL_EVENT_DESCRIPTION("animate,done");

void _efl_ui_flip_interaction_set(Eo *obj, Efl_Ui_Flip_Data *pd, Efl_Ui_Flip_Interaction mode);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_flip_interaction_set, EFL_FUNC_CALL(mode), Efl_Ui_Flip_Interaction mode);

Efl_Ui_Flip_Interaction _efl_ui_flip_interaction_get(const Eo *obj, Efl_Ui_Flip_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_flip_interaction_get, Efl_Ui_Flip_Interaction, 0);

Eina_Bool _efl_ui_flip_front_visible_get(const Eo *obj, Efl_Ui_Flip_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_flip_front_visible_get, Eina_Bool, 0);

void _efl_ui_flip_interaction_direction_hitsize_set(Eo *obj, Efl_Ui_Flip_Data *pd, Efl_Ui_Layout_Orientation dir, double hitsize);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_flip_interaction_direction_hitsize_set, EFL_FUNC_CALL(dir, hitsize), Efl_Ui_Layout_Orientation dir, double hitsize);

double _efl_ui_flip_interaction_direction_hitsize_get(Eo *obj, Efl_Ui_Flip_Data *pd, Efl_Ui_Layout_Orientation dir);

EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_ui_flip_interaction_direction_hitsize_get, double, 0, EFL_FUNC_CALL(dir), Efl_Ui_Layout_Orientation dir);

void _efl_ui_flip_interaction_direction_enabled_set(Eo *obj, Efl_Ui_Flip_Data *pd, Efl_Ui_Layout_Orientation dir, Eina_Bool enabled);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_flip_interaction_direction_enabled_set, EFL_FUNC_CALL(dir, enabled), Efl_Ui_Layout_Orientation dir, Eina_Bool enabled);

Eina_Bool _efl_ui_flip_interaction_direction_enabled_get(Eo *obj, Efl_Ui_Flip_Data *pd, Efl_Ui_Layout_Orientation dir);

EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_ui_flip_interaction_direction_enabled_get, Eina_Bool, 0, EFL_FUNC_CALL(dir), Efl_Ui_Layout_Orientation dir);

void _efl_ui_flip_go(Eo *obj, Efl_Ui_Flip_Data *pd, Efl_Ui_Flip_Mode mode);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_flip_go, EFL_FUNC_CALL(mode), Efl_Ui_Flip_Mode mode);

void _efl_ui_flip_go_to(Eo *obj, Efl_Ui_Flip_Data *pd, Eina_Bool front, Efl_Ui_Flip_Mode mode);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_flip_go_to, EFL_FUNC_CALL(front, mode), Eina_Bool front, Efl_Ui_Flip_Mode mode);

Efl_Object *_efl_ui_flip_efl_object_constructor(Eo *obj, Efl_Ui_Flip_Data *pd);


Eina_Bool _efl_ui_flip_efl_ui_widget_widget_sub_object_add(Eo *obj, Efl_Ui_Flip_Data *pd, Efl_Canvas_Object *sub_obj);


Eina_Error _efl_ui_flip_efl_ui_widget_theme_apply(Eo *obj, Efl_Ui_Flip_Data *pd);


Eina_Bool _efl_ui_flip_efl_ui_widget_widget_sub_object_del(Eo *obj, Efl_Ui_Flip_Data *pd, Efl_Canvas_Object *sub_obj);


Eina_Iterator *_efl_ui_flip_efl_container_content_iterate(Eo *obj, Efl_Ui_Flip_Data *pd);


int _efl_ui_flip_efl_container_content_count(Eo *obj, Efl_Ui_Flip_Data *pd);


Efl_Object *_efl_ui_flip_efl_part_part_get(const Eo *obj, Efl_Ui_Flip_Data *pd, const char *name);


Eina_Bool _efl_ui_flip_efl_pack_unpack(Eo *obj, Efl_Ui_Flip_Data *pd, Efl_Gfx_Entity *subobj);


Eina_Bool _efl_ui_flip_efl_pack_pack(Eo *obj, Efl_Ui_Flip_Data *pd, Efl_Gfx_Entity *subobj);


Eina_Bool _efl_ui_flip_efl_pack_linear_pack_begin(Eo *obj, Efl_Ui_Flip_Data *pd, Efl_Gfx_Entity *subobj);


Eina_Bool _efl_ui_flip_efl_pack_linear_pack_end(Eo *obj, Efl_Ui_Flip_Data *pd, Efl_Gfx_Entity *subobj);


Eina_Bool _efl_ui_flip_efl_pack_linear_pack_before(Eo *obj, Efl_Ui_Flip_Data *pd, Efl_Gfx_Entity *subobj, const Efl_Gfx_Entity *existing);


Eina_Bool _efl_ui_flip_efl_pack_linear_pack_after(Eo *obj, Efl_Ui_Flip_Data *pd, Efl_Gfx_Entity *subobj, const Efl_Gfx_Entity *existing);


Eina_Bool _efl_ui_flip_efl_pack_linear_pack_at(Eo *obj, Efl_Ui_Flip_Data *pd, Efl_Gfx_Entity *subobj, int index);


Efl_Gfx_Entity *_efl_ui_flip_efl_pack_linear_pack_content_get(Eo *obj, Efl_Ui_Flip_Data *pd, int index);


Efl_Gfx_Entity *_efl_ui_flip_efl_pack_linear_pack_unpack_at(Eo *obj, Efl_Ui_Flip_Data *pd, int index);


int _efl_ui_flip_efl_pack_linear_pack_index_get(Eo *obj, Efl_Ui_Flip_Data *pd, const Efl_Gfx_Entity *subobj);


static Eina_Bool
_efl_ui_flip_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_UI_FLIP_EXTRA_OPS
#define EFL_UI_FLIP_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_ui_flip_interaction_set, _efl_ui_flip_interaction_set),
      EFL_OBJECT_OP_FUNC(efl_ui_flip_interaction_get, _efl_ui_flip_interaction_get),
      EFL_OBJECT_OP_FUNC(efl_ui_flip_front_visible_get, _efl_ui_flip_front_visible_get),
      EFL_OBJECT_OP_FUNC(efl_ui_flip_interaction_direction_hitsize_set, _efl_ui_flip_interaction_direction_hitsize_set),
      EFL_OBJECT_OP_FUNC(efl_ui_flip_interaction_direction_hitsize_get, _efl_ui_flip_interaction_direction_hitsize_get),
      EFL_OBJECT_OP_FUNC(efl_ui_flip_interaction_direction_enabled_set, _efl_ui_flip_interaction_direction_enabled_set),
      EFL_OBJECT_OP_FUNC(efl_ui_flip_interaction_direction_enabled_get, _efl_ui_flip_interaction_direction_enabled_get),
      EFL_OBJECT_OP_FUNC(efl_ui_flip_go, _efl_ui_flip_go),
      EFL_OBJECT_OP_FUNC(efl_ui_flip_go_to, _efl_ui_flip_go_to),
      EFL_OBJECT_OP_FUNC(efl_constructor, _efl_ui_flip_efl_object_constructor),
      EFL_OBJECT_OP_FUNC(efl_ui_widget_sub_object_add, _efl_ui_flip_efl_ui_widget_widget_sub_object_add),
      EFL_OBJECT_OP_FUNC(efl_ui_widget_theme_apply, _efl_ui_flip_efl_ui_widget_theme_apply),
      EFL_OBJECT_OP_FUNC(efl_ui_widget_sub_object_del, _efl_ui_flip_efl_ui_widget_widget_sub_object_del),
      EFL_OBJECT_OP_FUNC(efl_content_iterate, _efl_ui_flip_efl_container_content_iterate),
      EFL_OBJECT_OP_FUNC(efl_content_count, _efl_ui_flip_efl_container_content_count),
      EFL_OBJECT_OP_FUNC(efl_part_get, _efl_ui_flip_efl_part_part_get),
      EFL_OBJECT_OP_FUNC(efl_pack_unpack, _efl_ui_flip_efl_pack_unpack),
      EFL_OBJECT_OP_FUNC(efl_pack, _efl_ui_flip_efl_pack_pack),
      EFL_OBJECT_OP_FUNC(efl_pack_begin, _efl_ui_flip_efl_pack_linear_pack_begin),
      EFL_OBJECT_OP_FUNC(efl_pack_end, _efl_ui_flip_efl_pack_linear_pack_end),
      EFL_OBJECT_OP_FUNC(efl_pack_before, _efl_ui_flip_efl_pack_linear_pack_before),
      EFL_OBJECT_OP_FUNC(efl_pack_after, _efl_ui_flip_efl_pack_linear_pack_after),
      EFL_OBJECT_OP_FUNC(efl_pack_at, _efl_ui_flip_efl_pack_linear_pack_at),
      EFL_OBJECT_OP_FUNC(efl_pack_content_get, _efl_ui_flip_efl_pack_linear_pack_content_get),
      EFL_OBJECT_OP_FUNC(efl_pack_unpack_at, _efl_ui_flip_efl_pack_linear_pack_unpack_at),
      EFL_OBJECT_OP_FUNC(efl_pack_index_get, _efl_ui_flip_efl_pack_linear_pack_index_get),
      EFL_UI_FLIP_EXTRA_OPS
   );
   opsp = &ops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_ui_flip_class_desc = {
   EO_VERSION,
   "Efl.Ui.Flip",
   EFL_CLASS_TYPE_REGULAR,
   sizeof(Efl_Ui_Flip_Data),
   _efl_ui_flip_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_ui_flip_class_get, &_efl_ui_flip_class_desc, EFL_UI_WIDGET_CLASS, EFL_PACK_LINEAR_INTERFACE, NULL);
